;;; FLX_DIM.LSP
;;; ============================================================================
;;; Provided by Felix Computer Aided Technologies GmbH 1995-96
;;; Created: Jan 20, 1996 / vp
;;; Changed: Sept 29, 1996 / vp
;;; ============================================================================

(defun FLX_DIMDIALOG (dlg_file dlg_id / dlg_file dlg_id DIM_INIT cmd flag
                                        pal1 pal2 cmd_list help_keyword)

  (setq pal1 "fc_dim.mnp" pal2 "fc_edim.mnp")

  (setq help_keyword "Dimensioning Summary")
  (setq cmd_list (list
       (list "DimHor"  ".DIMHOR")
       (list "DimVer"  ".DIMVER")
       (list "DimRot"  ".DIMROT")
       (list "DimAli"  ".DIMALI")
       (list "DimSer"  ".DIMSER")
       (list "DimCon"  ".DIMCON")
       (list "DimBas"  ".DIMBAS")
       (list "DimDia"  ".DIMDIA")
       (list "DimRad"  ".DIMRAD")
       (list "DimCent" ".DIMCENT")
       (list "DimA3P"  ".DIMA3P")
       (list "DimA4P"  ".DIMA4P")
       (list "DimOrd"  ".DIMORD")
       (list "DimUpd"  ".DIMUPD")
       (list "DimObl"  ".DIMOBL")
       (list "DimTnew"  ".DIMTNEW")
       (list "DimTmove" ".DIMTMOVE")
       (list "DimThome" ".DIMTHOME")
       (list "DimTrot"  ".DIMTROT")
       (list "DimType"  ".DIMTYPE")
  ))
  (if FLX_XLANGUAGE (FLX_XLANGUAGE "_dim" "_dimdialog"))
  ;;; --------------------------------------------------

  (if (> (getvar "ACTDB") -1) (progn
   (defun *ERROR* (msg) (setvar "CMDECHO" 1)(setq *ERROR* nil)(princ)) 
   ;----------------------------------------------------------------------------
   (defun DIM_INIT ( / n n1)
      (if FLX$WIN95 (foreach n '("IDCANCEL" "IDHELP")(Dlg_TileSetFont n 2)))
      (foreach n1 cmd_list
         (Dlg_TileAction
            (car n1)
            (strcat "(setq cmd \"" (cadr n1) "\")(Dlg_DialogDone)")
         )
      )
      (Dlg_TileAction "DimDrawPal" "(setq cmd \"DIMDRAWPAL\")(Dlg_DialogDone)")
      (Dlg_TileAction "DimEditPal" "(setq cmd \"DIMEDITPAL\")(Dlg_DialogDone)")
      (Dlg_TileAction "IDCANCEL"   "(setq cmd nil)(Dlg_DialogDone)")
      (Dlg_TileAction "IDHELP"     "(help help_keyword)")
   )
   ;----------------------------------------------------------------------------
   (setq flag T)
   (while flag
      (setq cmd nil)
      (if (FLX_DLGDSP dlg_file dlg_id "(princ)" "(Dim_Init)") (princ) (exit))
      (if cmd 
        (progn
          (setvar "CMDECHO" 1)
          (cond
            ((= cmd "DIMDRAWPAL") (PALNEXT pal1)(setq flag nil)) ;;;fc_dim.mnp
            ((= cmd "DIMEDITPAL") (PALNEXT pal2)(setq flag nil)) ;;;fc_edim.mnp
            ((= cmd ".DIMTYPE")   (command ".DIMTYPE"))   ;;; DIMTYPE dialog box
            ((= cmd ".BEMTYP")    (command ".BEMTYP"))    ;;; " (german command) 
            ;;; TRUE: princ command name and execute command
            (T
               (princ (substr cmd 2))(terpri)
               (command cmd)(setq flag nil)
            ) 
          ) ; cond
        )
        (setq flag nil)
      )
   )
   (setq *ERROR* nil) 
 )) ;;; ACTDB end
)

; -------------------------------------------------------------------------------

(defun FLX_DIMREST ( / e1 elst dimtyp prt_lst)

    (setq prt_list (list
          "Set dimension type by reference dimension.\n"
          "Dimension type "
          " set!"
          "No style assigned to that dimension!"
          "No dimension selected!"
    )) 
    (if FLX_XLANGUAGE (FLX_XLANGUAGE "_dim" "_dimrest"))

    (FLX_FUNC_INIT)
    (princ (nth 0 prt_list))
    (if (setq e1 (entsel))
      (progn
        (setq elst (entget (car e1)))
        (if (= (cdr (assoc 0 elst)) "DIMENSION")
           (progn
             (if (and (/= (setq dimtyp (cdr (assoc 3 elst))) "*UNNAMED") 
                      (assoc 3 elst)
                 )
                  (progn
                    (tblset "DIMSTYLE" dimtyp)
                    (princ (strcat 
                       (nth 1 prt_list) dimtyp (nth 2 prt_list) 
                    ))
                   )
                   (princ (nth 3 prt_list))
               )
             )
          )
      )
      (princ (nth 4 prt_list) )
    )
    (FLX_FUNC_EXIT)
    (princ)
)

; -------------------------------------------------------------------------------

(princ)

